package cn.com.started.msuserservice.controller;

import cn.com.started.msuserservice.api.OrderService;
import cn.com.started.msuserservice.dao.SysAccountMapper;
import cn.com.started.msuserservice.model.SysAccount;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.concurrent.TimeUnit;

@RestController
public class UserController {
    @Autowired
    private OrderService orderService;
//    @Autowired
//    private RedisTemplate redisTemplate;
//    @Autowired
//    private SysAccountMapper sysAccountMapper;

    @RequestMapping("test")
    public String userTest() {
        return orderService.test();
    }

//    @RequestMapping("mybatisTest")
//    public SysAccount mybatisTest(){
//        return sysAccountMapper.selectByPrimaryKey("1");
//    }
//
//    @RequestMapping("redisTest")
//    public String redisTest(){
//        redisTemplate.opsForValue().set("num",123,10, TimeUnit.SECONDS);
//        return redisTemplate.opsForValue().get("num").toString();
//    }

    @RequestMapping("getBase2")
    public void getAudio(HttpServletRequest request, HttpServletResponse response) throws Exception {
        String range = "3";

        URL url = new URL("https://music.kuke.com/1592802937059/a98f58b22f6b2daafb987424dd67af33/mp3/highbit/BRIDGE/100031-2/10003101_04_full_wm_192.mp3");
        HttpURLConnection conn = (HttpURLConnection) url.openConnection();
        // 设置超时间为3秒
        conn.setConnectTimeout(3 * 1000);
        // 防止屏蔽程序抓取而返回403错误
        conn.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 5.0; Windows NT; DigExt)");
        // 设定请求的方法，默认是GET 这里不能使用post提交
        conn.setRequestMethod("GET");
        // 设置字符编码
        conn.setRequestProperty("Charset", "UTF-8");
        // 打开到此 URL 引用的资源的通信链接（如果尚未建立这样的连接）。
        conn.connect();
        // 文件大小
        int length = conn.getContentLength();

        response.addHeader("Accept-Ranges", "bytes");
        response.addHeader("Content-Length", length + "");
        response.addHeader("Content-Range", "bytes " + range + "-" + length + "/" + length);
        response.addHeader("Content-Type", "audio/mpeg;charset=UTF-8");

        // 得到输入流
        InputStream inputStream = conn.getInputStream();
        // 获取自己数组
        byte[] getData = readInputStream(inputStream, length);
        OutputStream os = response.getOutputStream();
        os.write(getData);
        os.close();
    }

    /**
     * 从输入流中获取字节数组
     *
     * @param inputStream
     * @return
     * @throws IOException
     */
    public static byte[] readInputStream(InputStream inputStream, int fileLength)
            throws IOException {
        int bt = 192, start = 1, end = 60;

        int sta = bt * start * 1024 / 8;
        //计算结束截取的字节
        int en = bt * end * 1024 / 8;

        byte[] buffer = new byte[1024];
        int len = 0;
        int size = 0;
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        while ((len = inputStream.read(buffer)) != -1) {
            size += len;
            //判断字节是否小于要截取的字节数
            if (size < sta)
                continue;
            //判断字节是否大于要截取的字节数，大于则跳出循环
            if (size > en)
                break;
            bos.write(buffer, 0, len);
            //打印下载的百分比
            //System.out.println("下载了-------> " + size * 100 / fileLength + "%\n");
        }
        bos.close();
        return bos.toByteArray();
    }

}
